
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Mean wave parameres derived from the 2D wave spectra &#8212; My sample book</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <link rel="stylesheet" href="_static/sphinx-book-theme.acff12b8f9c144ce68a297486a2fa670.css" type="text/css" />
    <link rel="stylesheet" type="text/css" href="_static/togglebutton.css" />
    <link rel="stylesheet" type="text/css" href="_static/copybutton.css" />
    <link rel="stylesheet" type="text/css" href="_static/mystnb.css" />
    <link rel="stylesheet" type="text/css" href="_static/sphinx-thebe.css" />
    <link rel="stylesheet" type="text/css" href="_static/panels-main.c949a650a448cc0ae9fd3441c0e17fb0.css" />
    <link rel="stylesheet" type="text/css" href="_static/panels-variables.06eb56fa6e07937060861dad626602ad.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script src="_static/togglebutton.js"></script>
    <script src="_static/clipboard.min.js"></script>
    <script src="_static/copybutton.js"></script>
    <script >var togglebuttonSelector = '.toggle, .admonition.dropdown, .tag_hide_input div.cell_input, .tag_hide-input div.cell_input, .tag_hide_output div.cell_output, .tag_hide-output div.cell_output, .tag_hide_cell.cell, .tag_hide-cell.cell';</script>
    <script src="_static/sphinx-book-theme.12a9622fbb08dcb3a2a40b2c02b83a57.js"></script>
    <script async="async" src="https://unpkg.com/thebelab@latest/lib/index.js"></script>
    <script >
        const thebe_selector = ".thebe"
        const thebe_selector_input = "pre"
        const thebe_selector_output = ".output"
    </script>
    <script async="async" src="_static/sphinx-thebe.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <link rel="next" title="Swell Field reconstruction" href="SF6_SwellField_Reconstruction.html" />
    <link rel="prev" title="Comparison between WW3 model and CFOSAT partitions" href="SF4_Partitions_ModelCFOSAT.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    

    <div class="container-xl">
      <div class="row">
          
<div class="col-12 col-md-3 bd-sidebar site-navigation show" id="site-navigation">
    
        <div class="navbar-brand-box">
    <a class="navbar-brand text-wrap" href="index.html">
      
      <img src="_static/logo.png" class="logo" alt="logo">
      
      
      <h1 class="site-logo" id="site-title">My sample book</h1>
      
    </a>
</div><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search this book..." aria-label="Search this book..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
    <div class="bd-toc-item active">
        <ul class="nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="intro.html">
   Welcome to your Jupyter Book
  </a>
 </li>
</ul>
<ul class="current nav bd-sidenav">
 <li class="toctree-l1">
  <a class="reference internal" href="SF1_SpatialTemporal_Selection.html">
   Selection of CFOSAT passes over the ESTELA area
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF2_Passes_Viewer.html">
   Visualization of Satellite passes
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF3_ModelSat_animation.html">
   Animation Satellite Model
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF4_Partitions_ModelCFOSAT.html">
   Comparison between WW3 model and CFOSAT partitions
  </a>
 </li>
 <li class="toctree-l1 current active">
  <a class="current reference internal" href="#">
   Mean wave parameres derived from the 2D wave spectra
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF6_SwellField_Reconstruction.html">
   Swell Field reconstruction
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF7_CFOSAT_ForecastBins.html">
   Wrap
  </a>
 </li>
 <li class="toctree-l1">
  <a class="reference internal" href="SF8_Superspectra_Validation.html">
   CFOSAT-based swells forecast
  </a>
 </li>
</ul>

    </div>
</nav> <!-- To handle the deprecated key -->

<div class="navbar_extra_footer">
  Powered by <a href="https://jupyterbook.org">Jupyter Book</a>
</div>

</div>


          


          
<main class="col py-md-3 pl-md-4 bd-content overflow-auto" role="main">
    
    <div class="topbar container-xl fixed-top">
    <div class="topbar-contents row">
        <div class="col-12 col-md-3 bd-topbar-whitespace site-navigation show"></div>
        <div class="col pl-md-4 topbar-main">
            
            <button id="navbar-toggler" class="navbar-toggler ml-0" type="button" data-toggle="collapse"
                data-toggle="tooltip" data-placement="bottom" data-target=".site-navigation" aria-controls="navbar-menu"
                aria-expanded="true" aria-label="Toggle navigation" aria-controls="site-navigation"
                title="Toggle navigation" data-toggle="tooltip" data-placement="left">
                <i class="fas fa-bars"></i>
                <i class="fas fa-arrow-left"></i>
                <i class="fas fa-arrow-up"></i>
            </button>
            
            
<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn" aria-label="Download this page"><i
            class="fas fa-download"></i></button>

    <div class="dropdown-buttons">
        <!-- ipynb file if we had a myst markdown file -->
        
        <!-- Download raw file -->
        <a class="dropdown-buttons" href="_sources/SF5_Skt_SpectralProcessing.ipynb"><button type="button"
                class="btn btn-secondary topbarbtn" title="Download source file" data-toggle="tooltip"
                data-placement="left">.ipynb</button></a>
        <!-- Download PDF via print -->
        <button type="button" id="download-print" class="btn btn-secondary topbarbtn" title="Print to PDF"
            onClick="window.print()" data-toggle="tooltip" data-placement="left">.pdf</button>
    </div>
</div>

            <!-- Source interaction buttons -->

<div class="dropdown-buttons-trigger">
    <button id="dropdown-buttons-trigger" class="btn btn-secondary topbarbtn"
        aria-label="Connect with source repository"><i class="fab fa-github"></i></button>
    <div class="dropdown-buttons sourcebuttons">
        <a class="repository-button"
            href="https://gitlab.com/AlbaRicondo/cfosat-forecast"><button type="button" class="btn btn-secondary topbarbtn"
                data-toggle="tooltip" data-placement="left" title="Source repository"><i
                    class="fab fa-github"></i>repository</button></a>
        <a class="issues-button"
            href="https://gitlab.com/AlbaRicondo/cfosat-forecast/issues/new?title=Issue%20on%20page%20%2FSF5_Skt_SpectralProcessing.html&body=Your%20issue%20content%20here."><button
                type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip" data-placement="left"
                title="Open an issue"><i class="fas fa-lightbulb"></i>open issue</button></a>
        
    </div>
</div>

            <!-- Full screen (wrap in <a> to have style consistency -->

<a class="full-screen-button"><button type="button" class="btn btn-secondary topbarbtn" data-toggle="tooltip"
        data-placement="bottom" onclick="toggleFullScreen()" aria-label="Fullscreen mode"
        title="Fullscreen mode"><i
            class="fas fa-expand"></i></button></a>

            <!-- Launch buttons -->

        </div>

        <!-- Table of contents -->
        <div class="d-none d-md-block col-md-2 bd-toc show">
            
            <div class="tocsection onthispage pt-5 pb-3">
                <i class="fas fa-list"></i> Contents
            </div>
            <nav id="bd-toc-nav">
                <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#config-swim-parameters">
   Config SWIM parameters
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#cfosat-spectral-data">
   CFOSAT spectral data
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#model-spectral-data">
   Model spectral data
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#read-mfwam-parameters">
   Read MFWAM parameters
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#compute-raw-and-oneside-spectra">
   Compute raw and oneSide spectra
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#plot-2d-mean-slope-spectrum-from-cfosat-and-ww3-spectral-density">
   Plot 2D mean slope spectrum from CFOSAT and WW3 spectral density
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#plot-processed-partitions">
   Plot processed partitions
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#select-sector-and-compute-mean-parameters">
   Select sector and compute mean parameters
  </a>
 </li>
</ul>

            </nav>
        </div>
    </div>
</div>
    <div id="main-content" class="row">
        <div class="col-12 col-md-9 pl-md-3 pr-md-0">
        
              <div>
                
  <div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">os.path</span> <span class="k">as</span> <span class="nn">op</span>

<span class="kn">import</span> <span class="nn">glob</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">import</span> <span class="nn">pandas</span> <span class="k">as</span> <span class="nn">pd</span>
<span class="kn">import</span> <span class="nn">datetime</span>
<span class="kn">import</span> <span class="nn">netCDF4</span> <span class="k">as</span> <span class="nn">netcdf</span>
<span class="kn">from</span> <span class="nn">math</span> <span class="kn">import</span> <span class="n">pi</span>
<span class="kn">import</span> <span class="nn">xarray</span> <span class="k">as</span> <span class="nn">xr</span>
<span class="kn">import</span> <span class="nn">datetime</span>

<span class="kn">from</span> <span class="nn">matplotlib</span> <span class="kn">import</span> <span class="n">pyplot</span> <span class="k">as</span> <span class="n">plt</span>
<span class="kn">from</span> <span class="nn">matplotlib.lines</span> <span class="kn">import</span> <span class="n">Line2D</span> <span class="k">as</span> <span class="n">Line</span>
<span class="kn">from</span> <span class="nn">matplotlib.patches</span> <span class="kn">import</span> <span class="n">Patch</span>

<span class="c1"># cartopy maps</span>
<span class="kn">import</span> <span class="nn">cartopy.crs</span> <span class="k">as</span> <span class="nn">ccrs</span>
<span class="kn">from</span> <span class="nn">cartopy.io.shapereader</span> <span class="kn">import</span> <span class="n">Reader</span>
<span class="kn">from</span> <span class="nn">cartopy.feature</span> <span class="kn">import</span> <span class="n">ShapelyFeature</span>

<span class="c1"># kml read</span>
<span class="kn">from</span> <span class="nn">pykml</span> <span class="kn">import</span> <span class="n">parser</span>
<span class="kn">from</span> <span class="nn">geopy.distance</span> <span class="kn">import</span> <span class="n">geodesic</span>

<span class="c1"># dev library</span>
<span class="kn">import</span> <span class="nn">sys</span>
<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">insert</span><span class="p">(</span><span class="mi">0</span><span class="p">,</span> <span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="s1">&#39;&#39;</span><span class="p">),</span> <span class="s1">&#39;..&#39;</span><span class="p">))</span>

<span class="c1"># dependencies</span>
<span class="kn">from</span> <span class="nn">lib</span> <span class="kn">import</span> <span class="n">spectra</span><span class="p">,</span> <span class="n">plot_spectra</span><span class="p">,</span> <span class="n">wrapSpectra</span><span class="p">,</span> <span class="n">plot_sat</span><span class="p">,</span> <span class="n">io</span>
<span class="kn">from</span> <span class="nn">lib.config</span> <span class="kn">import</span> <span class="o">*</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="mean-wave-parameres-derived-from-the-2d-wave-spectra">
<h1>Mean wave parameres derived from the 2D wave spectra<a class="headerlink" href="#mean-wave-parameres-derived-from-the-2d-wave-spectra" title="Permalink to this headline">¶</a></h1>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># load data tracks and ww3 model output</span>
<span class="n">ds_data</span> <span class="o">=</span> <span class="n">xr</span><span class="o">.</span><span class="n">open_dataset</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">p_output</span><span class="p">,</span> <span class="s1">&#39;ds_dataTracks.nc&#39;</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="section" id="config-swim-parameters">
<h2>Config SWIM parameters<a class="headerlink" href="#config-swim-parameters" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># side of the nadir track to analyse (0 : right sides ; 1 :left side)</span>
<span class="n">nadir_side</span> <span class="o">=</span> <span class="mi">1</span>

<span class="c1"># beam choice for spectra : 6=&gt; beam 6°; 8=&gt; beam 8°; 10=&gt; beam 10° ; 0 =&gt; combined (combination of the 3 beams)</span>
<span class="n">beam</span> <span class="o">=</span> <span class="mi">10</span>

<span class="c1"># partitions visualization : True =&gt; partitions plotted; False =&gt; partitions not plotted</span>
<span class="n">partitions</span> <span class="o">=</span> <span class="kc">True</span>

<span class="c1"># color bar min and max values (&#39;None&#39; recommended)</span>
<span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span> <span class="o">=</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span>

<span class="c1"># wave wavelength visualization range:</span>
<span class="c1"># min wavelength (m), instrument specification :70m</span>
<span class="n">min_wavelength</span> <span class="o">=</span> <span class="mi">70</span>

<span class="c1"># max wavelength (m), instrument specification :500m</span>
<span class="n">max_wavelength</span> <span class="o">=</span> <span class="mi">500</span> 
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="cfosat-spectral-data">
<h2>CFOSAT spectral data<a class="headerlink" href="#cfosat-spectral-data" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># SWIM L2 NetCDF file full name (first file, first box)</span>
<span class="n">dsi</span> <span class="o">=</span> <span class="n">ds_data</span><span class="o">.</span><span class="n">isel</span><span class="p">(</span><span class="n">file</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span><span class="o">.</span><span class="n">dropna</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="s1">&#39;nbox&#39;</span><span class="p">)</span>
<span class="n">SWIM_L2_NC_file_name</span> <span class="o">=</span> <span class="nb">str</span><span class="p">(</span><span class="n">dsi</span><span class="o">.</span><span class="n">file</span><span class="o">.</span><span class="n">values</span><span class="p">)</span>
<span class="c1">#num_box = dsi.nbox.values[316]</span>
<span class="n">num_box</span> <span class="o">=</span> <span class="mi">316</span>
<span class="c1"># 50, 33: same tp opposite direcctions</span>

<span class="c1"># NetCDF file opening and reading</span>
<span class="n">cdf</span> <span class="o">=</span> <span class="n">netcdf</span><span class="o">.</span><span class="n">Dataset</span><span class="p">(</span><span class="n">glob</span><span class="o">.</span><span class="n">glob</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">sat_cfosat</span><span class="p">,</span>  <span class="s1">&#39;*&#39;</span><span class="p">,</span> <span class="n">SWIM_L2_NC_file_name</span><span class="p">))[</span><span class="mi">0</span><span class="p">])</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># example nadir_side = 0 (rigth)</span>
<span class="n">cell_text</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">partitions_info</span><span class="p">(</span><span class="n">cdf</span><span class="p">,</span> <span class="n">num_box</span><span class="p">,</span> <span class="n">nadir_side</span><span class="p">,</span> <span class="n">beam</span><span class="p">)</span>
<span class="n">cell_text</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output text_html"><div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }

    .dataframe tbody tr th {
        vertical-align: top;
    }

    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>partition</th>
      <th>SWH(m)</th>
      <th>wavelength(m)</th>
      <th>direction (°)</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>0</th>
      <td>1</td>
      <td>2.151</td>
      <td>194.388000</td>
      <td>113.823997</td>
    </tr>
    <tr>
      <th>1</th>
      <td>2</td>
      <td>1.969</td>
      <td>114.027000</td>
      <td>66.791000</td>
    </tr>
    <tr>
      <th>2</th>
      <td>3</td>
      <td>0.964</td>
      <td>45.318001</td>
      <td>93.386002</td>
    </tr>
  </tbody>
</table>
</div></div></div>
</div>
<p><strong>Parameters initialization</strong></p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Init variables</span>
<span class="n">time</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;time_spec_l2&#39;</span><span class="p">][:]</span>
<span class="n">lon</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;lon_spec_l2&#39;</span><span class="p">][:]</span>
<span class="n">lat</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;lat_spec_l2&#39;</span><span class="p">][:]</span>
<span class="n">K_SPECTRA</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;k_spectra&#39;</span><span class="p">][:]</span>
<span class="n">PARTI_COMB</span>  <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;mask_combined&#39;</span><span class="p">][:]</span>
<span class="n">PARTI_BEAM</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;mask&#39;</span><span class="p">][:]</span>
<span class="n">P_COMBINED</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;p_combined&#39;</span><span class="p">][:]</span>                
<span class="n">PP_MEAN</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;pp_mean&#39;</span><span class="p">][:]</span> 
<span class="n">N_KI</span>    <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="mi">32</span><span class="p">)</span><span class="c1">#int(65)</span>
<span class="n">N_PHI</span>  <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="mi">12</span><span class="p">)</span>
<span class="n">N_PARTITIONS</span> <span class="o">=</span> <span class="nb">int</span><span class="p">(</span><span class="mi">3</span><span class="p">)</span>
<span class="n">k_max</span> <span class="o">=</span> <span class="nb">round</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">pi</span><span class="o">/</span><span class="n">min_wavelength</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
<span class="n">k_min</span> <span class="o">=</span> <span class="nb">round</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">pi</span><span class="o">/</span><span class="n">max_wavelength</span><span class="p">,</span><span class="mi">3</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Get nadir box time and coordinates</span>
<span class="n">date</span> <span class="o">=</span> <span class="p">(</span><span class="n">t0</span> <span class="o">+</span> <span class="n">datetime</span><span class="o">.</span><span class="n">timedelta</span><span class="p">(</span><span class="n">seconds</span><span class="o">=</span><span class="nb">float</span><span class="p">(</span><span class="n">time</span><span class="p">[</span><span class="n">nadir_side</span><span class="p">,</span><span class="n">num_box</span><span class="p">,</span><span class="mi">0</span><span class="p">])))</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s1">&#39;%Y-%m-</span><span class="si">%d</span><span class="s1">T%H:%M:%S&#39;</span><span class="p">)</span>
<span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span> <span class="o">=</span> <span class="n">lon</span><span class="p">[</span><span class="n">nadir_side</span><span class="p">,</span> <span class="n">num_box</span><span class="p">],</span> <span class="n">lat</span><span class="p">[</span><span class="n">nadir_side</span><span class="p">,</span> <span class="n">num_box</span><span class="p">]</span>

<span class="c1"># get dom_azi</span>
<span class="n">dom_azi</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;wave_param_part&#39;</span><span class="p">][</span><span class="mi">2</span><span class="p">,:,</span><span class="n">nadir_side</span><span class="p">,</span><span class="n">num_box</span><span class="p">,</span><span class="nb">int</span><span class="p">((</span><span class="n">beam</span><span class="o">-</span><span class="mi">6</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)]</span>
<span class="n">dom_wl</span> <span class="o">=</span> <span class="n">cdf</span><span class="o">.</span><span class="n">variables</span><span class="p">[</span><span class="s1">&#39;wave_param_part&#39;</span><span class="p">][</span><span class="mi">1</span><span class="p">,:,</span><span class="n">nadir_side</span><span class="p">,</span><span class="n">num_box</span><span class="p">,</span><span class="nb">int</span><span class="p">((</span><span class="n">beam</span><span class="o">-</span><span class="mi">6</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)]</span>

<span class="c1"># display spectrum</span>
<span class="k">if</span> <span class="n">beam</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
    <span class="n">beam_title</span><span class="o">=</span><span class="s1">&#39;combined&#39;</span>
<span class="k">else</span><span class="p">:</span>
    <span class="n">PARTI_COMB</span> <span class="o">=</span> <span class="n">PARTI_BEAM</span><span class="p">[:,:,:,:,:,</span><span class="nb">int</span><span class="p">((</span><span class="n">beam</span><span class="o">-</span><span class="mi">6</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)]</span>
    <span class="n">P_COMBINED</span> <span class="o">=</span> <span class="n">PP_MEAN</span><span class="p">[:,:,:,:,</span><span class="nb">int</span><span class="p">((</span><span class="n">beam</span><span class="o">-</span><span class="mi">6</span><span class="p">)</span><span class="o">/</span><span class="mi">2</span><span class="p">)]</span>
    <span class="n">beam_title</span> <span class="o">=</span> <span class="s1">&#39;beam &#39;</span><span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">beam</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;$\degree$&#39;</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="model-spectral-data">
<h2>Model spectral data<a class="headerlink" href="#model-spectral-data" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">date64</span> <span class="o">=</span> <span class="n">datetime</span><span class="o">.</span><span class="n">datetime</span><span class="o">.</span><span class="n">strptime</span><span class="p">(</span><span class="n">date</span><span class="p">,</span> <span class="s2">&quot;%Y-%m-</span><span class="si">%d</span><span class="s2">T%H:%M:%S&quot;</span><span class="p">)</span>
<span class="n">dayYear</span> <span class="o">=</span> <span class="n">date64</span><span class="o">.</span><span class="n">strftime</span><span class="p">(</span><span class="s1">&#39;%j&#39;</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># WW3 model path</span>
<span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">ww3_spectra_proccessed</span><span class="p">,</span> <span class="n">dayYear</span><span class="p">))</span>
<span class="n">df_data</span> <span class="o">=</span> <span class="n">io</span><span class="o">.</span><span class="n">load_files</span><span class="p">(</span><span class="n">files</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># loc time and coordinates of Dataset</span>
<span class="n">nameFile</span> <span class="o">=</span> <span class="n">df_data</span><span class="o">.</span><span class="n">sort_values</span><span class="p">(</span><span class="s1">&#39;dates_st&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">loc</span><span class="p">[</span><span class="n">df_data</span><span class="o">.</span><span class="n">dates_st</span> <span class="o">&lt;</span> <span class="n">date</span><span class="p">]</span><span class="o">.</span><span class="n">iloc</span><span class="p">[[</span><span class="o">-</span><span class="mi">1</span><span class="p">]]</span><span class="o">.</span><span class="n">name</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">model_spec</span> <span class="o">=</span> <span class="n">xr</span><span class="o">.</span><span class="n">open_dataset</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">ww3_spectra_proccessed</span><span class="p">,</span> <span class="n">dayYear</span><span class="p">,</span> <span class="n">nameFile</span><span class="p">))</span>
<span class="n">model_spec</span> <span class="o">=</span> <span class="n">model_spec</span><span class="o">.</span><span class="n">isel</span><span class="p">(</span><span class="n">cell</span><span class="o">=</span><span class="n">nadir_side</span><span class="p">,</span> <span class="n">row</span><span class="o">=</span><span class="n">num_box</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Holtiujsen: wave density spectra ()</span>
<span class="c1"># sea surface wave directional variance spectral density (m2 s rad-1)</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="read-mfwam-parameters">
<h2>Read MFWAM parameters<a class="headerlink" href="#read-mfwam-parameters" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">file2</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">(</span><span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">mfawm</span><span class="p">,</span> <span class="s1">&#39;2021&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">dayYear</span><span class="p">))))[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">mfwam_data</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">read_csv</span><span class="p">(</span>
    <span class="n">op</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">mfawm</span><span class="p">,</span> <span class="s1">&#39;2021&#39;</span><span class="p">,</span> <span class="nb">str</span><span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="n">dayYear</span><span class="p">)),</span> <span class="n">file2</span><span class="p">),</span>
    <span class="n">delimiter</span><span class="o">=</span><span class="s1">&#39;\s+&#39;</span>
<span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">mfwam_sel</span> <span class="o">=</span> <span class="n">wrapSpectra</span><span class="o">.</span><span class="n">mfwam_info</span><span class="p">(</span><span class="n">SWIM_L2_NC_file_name</span><span class="p">,</span> <span class="n">date</span><span class="p">,</span> <span class="n">nadir_side</span><span class="p">,</span> <span class="n">num_box</span><span class="p">,</span> <span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">mfwam_sel</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output text_html"><div>
<style scoped>
    .dataframe tbody tr th:only-of-type {
        vertical-align: middle;
    }

    .dataframe tbody tr th {
        vertical-align: top;
    }

    .dataframe thead th {
        text-align: right;
    }
</style>
<table border="1" class="dataframe">
  <thead>
    <tr style="text-align: right;">
      <th></th>
      <th>DayL2</th>
      <th>HourL2</th>
      <th>DateMod</th>
      <th>lat</th>
      <th>lon</th>
      <th>latMod</th>
      <th>lonMod</th>
      <th>n_box</th>
      <th>posneg</th>
      <th>swh</th>
      <th>...</th>
      <th>mwd1</th>
      <th>mwp1</th>
      <th>swh2</th>
      <th>mwd2</th>
      <th>mwp2</th>
      <th>u10</th>
      <th>v10</th>
      <th>ucurr</th>
      <th>vcurr</th>
      <th>L2name</th>
    </tr>
  </thead>
  <tbody>
    <tr>
      <th>990</th>
      <td>20210521</td>
      <td>15103</td>
      <td>2021052103</td>
      <td>-62.73</td>
      <td>-86.69</td>
      <td>-62.7</td>
      <td>273.3</td>
      <td>317</td>
      <td>2</td>
      <td>3.36</td>
      <td>...</td>
      <td>289.44</td>
      <td>9.35</td>
      <td>0.86</td>
      <td>250.88</td>
      <td>14.65</td>
      <td>2.09</td>
      <td>3.55</td>
      <td>-0.04</td>
      <td>0.08</td>
      <td>CFO_OP05_SWI_L2_____F_20210521T005442_20210521...</td>
    </tr>
  </tbody>
</table>
<p>1 rows × 27 columns</p>
</div></div></div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">date</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output text_plain highlight-myst-ansi notranslate"><div class="highlight"><pre><span></span>&#39;2021-05-21T01:51:03&#39;
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="compute-raw-and-oneside-spectra">
<h2>Compute raw and oneSide spectra<a class="headerlink" href="#compute-raw-and-oneside-spectra" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># ds_Raw - 0º at the North, (0-360º)</span>
<span class="c1"># [&#39;90&#39;,&#39;60&#39;,&#39;30&#39;,&#39;0&#39;,&#39;330&#39;,&#39;300&#39;,&#39;270&#39;,&#39;240&#39;,&#39;210&#39;,&#39;180&#39;,&#39;150&#39;,&#39;120&#39;])</span>
</pre></div>
</div>
</div>
</div>
<p><strong>Mask the partitions with no correlation in WW3 model</strong></p>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">dom_azi_pro</span> <span class="o">=</span> <span class="n">wrapSpectra</span><span class="o">.</span><span class="n">dir_ambiguity</span><span class="p">(</span><span class="n">dom_azi</span><span class="p">,</span> <span class="n">dom_wl</span><span class="p">,</span> <span class="n">mfwam_sel</span><span class="p">,</span> <span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">)</span>

<span class="c1"># PARTI_COMB: mask of detected partitions</span>
<span class="n">parts_nan</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">isnan</span><span class="p">(</span><span class="n">dom_azi_pro</span><span class="o">.</span><span class="n">data</span><span class="p">))[</span><span class="mi">0</span><span class="p">]</span>
<span class="n">PARTI_COMB</span><span class="p">[:,:,</span><span class="n">parts_nan</span><span class="p">,</span><span class="n">nadir_side</span><span class="p">,</span><span class="n">num_box</span><span class="p">]</span> <span class="o">=</span> <span class="mi">0</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">cell_model</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span>
    <span class="p">{</span>
        <span class="s1">&#39;partition&#39;</span><span class="p">:[</span><span class="mi">1</span><span class="p">,</span> <span class="mi">2</span><span class="p">,</span> <span class="mi">3</span><span class="p">],</span>
        <span class="s1">&#39;Dir&#39;</span><span class="p">:</span> <span class="p">[</span><span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mdww</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mwd1</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mwd2</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">]],</span>
        <span class="s1">&#39;Tp&#39;</span><span class="p">:</span> <span class="p">[</span><span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mpww</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mwp1</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">mfwam_sel</span><span class="o">.</span><span class="n">mwp2</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="mi">0</span><span class="p">]]</span> 
    <span class="p">}</span>
<span class="p">)</span>
<span class="n">cell_model</span><span class="p">[</span><span class="s1">&#39;Wl&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="p">(</span><span class="n">g</span><span class="o">*</span><span class="n">cell_model</span><span class="p">[</span><span class="s1">&#39;Tp&#39;</span><span class="p">]</span><span class="o">**</span><span class="mi">2</span><span class="p">)</span><span class="o">/</span><span class="p">(</span><span class="mi">2</span><span class="o">*</span><span class="n">np</span><span class="o">.</span><span class="n">pi</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="plot-2d-mean-slope-spectrum-from-cfosat-and-ww3-spectral-density">
<h2>Plot 2D mean slope spectrum from CFOSAT and WW3 spectral density<a class="headerlink" href="#plot-2d-mean-slope-spectrum-from-cfosat-and-ww3-spectral-density" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># compute origial spectra from CFOSAT</span>
<span class="n">ds_Raw</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">rawSpectra</span><span class="p">(</span><span class="n">P_COMBINED</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> <span class="n">dom_azi</span><span class="p">,</span> 
                    <span class="n">posneg</span><span class="o">=</span><span class="n">nadir_side</span><span class="p">,</span> 
                    <span class="n">box</span><span class="o">=</span><span class="n">num_box</span><span class="p">,</span> <span class="n">n_k</span><span class="o">=</span><span class="n">N_KI</span><span class="p">,</span> <span class="n">n_phi</span><span class="o">=</span><span class="n">N_PHI</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span> 
                    <span class="n">n_partitions</span><span class="o">=</span><span class="n">N_PARTITIONS</span><span class="p">)</span>

<span class="c1"># eliminate 180º ambiguity</span>
<span class="n">ds_oneSide</span><span class="p">,</span> <span class="n">mask_comb_or</span><span class="p">,</span> <span class="n">mask_comb</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">oneSide</span><span class="p">(</span><span class="n">ds_Raw</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> <span class="n">PARTI_COMB</span><span class="p">,</span> <span class="n">dom_azi</span><span class="p">,</span>
                     <span class="n">posneg</span><span class="o">=</span><span class="n">nadir_side</span><span class="p">,</span> <span class="n">box</span><span class="o">=</span><span class="n">num_box</span><span class="p">,</span>
                     <span class="n">n_k</span><span class="o">=</span><span class="n">N_KI</span><span class="p">,</span>
                     <span class="n">n_phi</span><span class="o">=</span><span class="n">N_PHI</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span>
                     <span class="n">n_partitions</span><span class="o">=</span><span class="n">N_PARTITIONS</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># compute origial spectra from CFOSAT</span>
<span class="n">ds_Raw_pro</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">rawSpectra</span><span class="p">(</span><span class="n">P_COMBINED</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> <span class="n">dom_azi_pro</span><span class="p">,</span> 
                    <span class="n">posneg</span><span class="o">=</span><span class="n">nadir_side</span><span class="p">,</span> 
                    <span class="n">box</span><span class="o">=</span><span class="n">num_box</span><span class="p">,</span> <span class="n">n_k</span><span class="o">=</span><span class="n">N_KI</span><span class="p">,</span> <span class="n">n_phi</span><span class="o">=</span><span class="n">N_PHI</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span> 
                    <span class="n">n_partitions</span><span class="o">=</span><span class="n">N_PARTITIONS</span><span class="p">)</span>

<span class="c1"># eliminate 180º ambiguity</span>
<span class="n">ds_oneSide_pro</span><span class="p">,</span> <span class="n">mask_comb_pro_or</span><span class="p">,</span> <span class="n">mask_comb_pro</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">oneSide</span><span class="p">(</span><span class="n">ds_Raw_pro</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> <span class="n">PARTI_COMB</span><span class="p">,</span> <span class="n">dom_azi_pro</span><span class="p">,</span>
                     <span class="n">posneg</span><span class="o">=</span><span class="n">nadir_side</span><span class="p">,</span> <span class="n">box</span><span class="o">=</span><span class="n">num_box</span><span class="p">,</span>
                     <span class="n">n_k</span><span class="o">=</span><span class="n">N_KI</span><span class="p">,</span>
                     <span class="n">n_phi</span><span class="o">=</span><span class="n">N_PHI</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span>
                     <span class="n">n_partitions</span><span class="o">=</span><span class="n">N_PARTITIONS</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">wave_spec</span> <span class="o">=</span> <span class="n">ds_oneSide</span><span class="o">.</span><span class="n">assign_coords</span><span class="p">(</span><span class="n">lon</span><span class="o">=</span><span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat</span><span class="o">=</span><span class="n">lat_coor</span><span class="p">,</span> <span class="n">date</span><span class="o">=</span><span class="n">date</span><span class="p">)</span>
<span class="n">da_spectra</span> <span class="o">=</span> <span class="n">wave_spec</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="s1">&#39;part&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">slopeD</span>

<span class="n">wave_spec_pro</span> <span class="o">=</span> <span class="n">ds_oneSide_pro</span><span class="o">.</span><span class="n">assign_coords</span><span class="p">(</span><span class="n">lon</span><span class="o">=</span><span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat</span><span class="o">=</span><span class="n">lat_coor</span><span class="p">,</span> <span class="n">date</span><span class="o">=</span><span class="n">date</span><span class="p">)</span>
<span class="n">da_spectra_pro</span> <span class="o">=</span> <span class="n">wave_spec_pro</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="s1">&#39;part&#39;</span><span class="p">)</span><span class="o">.</span><span class="n">slopeD</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span> <span class="o">=</span> <span class="mi">0</span><span class="p">,</span> <span class="n">ds_Raw_pro</span><span class="o">.</span><span class="n">data</span><span class="o">.</span><span class="n">max</span><span class="p">()</span>
<span class="n">l_min</span><span class="p">,</span> <span class="n">l_max</span> <span class="o">=</span> <span class="mi">30</span><span class="p">,</span> <span class="mi">400</span>

<span class="n">partitions</span> <span class="o">=</span> <span class="kc">True</span>
<span class="n">cmap</span> <span class="o">=</span> <span class="s1">&#39;rainbow&#39;</span>

<span class="c1"># partitions-spectra map</span>
<span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">15</span><span class="p">,</span><span class="mi">12</span><span class="p">),</span> <span class="n">constrained_layout</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="n">gs</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_gridspec</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span><span class="mi">3</span><span class="p">,</span> <span class="n">wspace</span><span class="o">=</span><span class="mf">0.2</span><span class="p">)</span>
<span class="n">axt</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">0</span><span class="p">],</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;polar&#39;</span><span class="p">)</span>
<span class="n">axb</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">1</span><span class="p">],</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;polar&#39;</span><span class="p">)</span>
<span class="n">axc</span> <span class="o">=</span> <span class="n">fig</span><span class="o">.</span><span class="n">add_subplot</span><span class="p">(</span><span class="n">gs</span><span class="p">[</span><span class="mi">0</span><span class="p">,</span> <span class="mi">2</span><span class="p">],</span> <span class="n">projection</span><span class="o">=</span><span class="s1">&#39;polar&#39;</span><span class="p">)</span>

<span class="c1"># plot the SWIM 2D wave spectra for the selected box fig, gs, wave_spec, mask_comb, K_SPECTRA</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">axt</span> <span class="o">=</span> <span class="n">plot_spectra</span><span class="o">.</span><span class="n">plotSpectra</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">axt</span><span class="p">,</span> <span class="n">ds_Raw_pro</span><span class="p">,</span> <span class="n">mask_comb_or</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> 
              <span class="n">num_box</span><span class="p">,</span> <span class="n">nadir_side</span><span class="p">,</span>
              <span class="n">N_PHI</span><span class="p">,</span> <span class="n">l_min</span><span class="p">,</span> <span class="n">l_max</span><span class="p">,</span>
              <span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span><span class="p">,</span> <span class="kc">True</span><span class="p">,</span>
              <span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">,</span> <span class="n">date</span><span class="p">)</span>

<span class="n">fig</span><span class="p">,</span> <span class="n">axb</span> <span class="o">=</span> <span class="n">plot_spectra</span><span class="o">.</span><span class="n">plotSpectra</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">axb</span><span class="p">,</span> <span class="n">da_spectra_pro</span><span class="p">,</span> <span class="n">mask_comb_pro</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> 
                  <span class="n">num_box</span><span class="p">,</span> <span class="n">nadir_side</span><span class="p">,</span>
                  <span class="n">N_PHI</span><span class="p">,</span> <span class="n">l_min</span><span class="p">,</span> <span class="n">l_max</span><span class="p">,</span>
                  <span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span><span class="p">,</span> <span class="n">partitions</span><span class="p">,</span>
                  <span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">,</span> <span class="n">date</span><span class="p">)</span>

<span class="n">title</span> <span class="o">=</span> <span class="s1">&#39;2D slope spectrum WW3, for box: &#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">num_box</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;, posneg: &#39;</span><span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">nadir_side</span><span class="p">)</span>
<span class="n">suptitle</span> <span class="o">=</span> <span class="s1">&#39;</span><span class="se">\n</span><span class="s1">Coordinates: </span><span class="si">{0:.2f}</span><span class="s1">°, </span><span class="si">{1:.2f}</span><span class="s1">°</span><span class="se">\n</span><span class="s1">Date: </span><span class="si">{2}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">model_spec</span><span class="o">.</span><span class="n">lon</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">model_spec</span><span class="o">.</span><span class="n">lat</span><span class="o">.</span><span class="n">values</span><span class="p">,</span> <span class="n">model_spec</span><span class="o">.</span><span class="n">time</span><span class="o">.</span><span class="n">values</span><span class="p">)</span>
<span class="n">title</span> <span class="o">+=</span> <span class="n">suptitle</span>
    
<span class="n">fig</span><span class="p">,</span> <span class="n">axc</span> <span class="o">=</span> <span class="n">plot_spectra</span><span class="o">.</span><span class="n">plotModel</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">axc</span><span class="p">,</span> <span class="n">model_spec</span><span class="p">,</span> <span class="n">cmap</span><span class="p">,</span> <span class="n">title</span><span class="p">,</span> <span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span><span class="p">,</span> <span class="n">l_min</span><span class="p">,</span> <span class="n">l_max</span><span class="p">)</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<img alt="_images/SF5_Skt_SpectralProcessing_34_0.png" src="_images/SF5_Skt_SpectralProcessing_34_0.png" />
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">sys</span><span class="o">.</span><span class="n">exit</span><span class="p">()</span>
</pre></div>
</div>
</div>
<div class="cell_output docutils container">
<div class="output traceback highlight-ipythontb notranslate"><div class="highlight"><pre><span></span><span class="n">An</span> <span class="n">exception</span> <span class="n">has</span> <span class="n">occurred</span><span class="p">,</span> <span class="n">use</span> <span class="o">%</span><span class="k">tb</span> to see the full traceback.

<span class="ne">SystemExit</span>
</pre></div>
</div>
</div>
</div>
</div>
<div class="section" id="plot-processed-partitions">
<h2>Plot processed partitions<a class="headerlink" href="#plot-processed-partitions" title="Permalink to this headline">¶</a></h2>
</div>
<div class="section" id="select-sector-and-compute-mean-parameters">
<h2>Select sector and compute mean parameters<a class="headerlink" href="#select-sector-and-compute-mean-parameters" title="Permalink to this headline">¶</a></h2>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">distance</span><span class="p">,</span> <span class="n">bearing</span><span class="p">,</span> <span class="n">bearing_p1</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">geoBearing</span><span class="p">(</span><span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">)</span>

<span class="c1"># Select sector and compute mean parameters</span>
<span class="n">ds_spectra</span> <span class="o">=</span> <span class="n">ds_oneSide</span><span class="o">.</span><span class="n">sum</span><span class="p">(</span><span class="n">dim</span><span class="o">=</span><span class="s1">&#39;part&#39;</span><span class="p">)</span>
<span class="n">ds_sector</span> <span class="o">=</span> <span class="n">ds_spectra</span><span class="o">.</span><span class="n">isel</span><span class="p">(</span><span class="n">theta</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">ds_spectra</span><span class="o">.</span><span class="n">theta</span><span class="o">.</span><span class="n">values</span> <span class="o">-</span> <span class="n">bearing</span><span class="p">)))</span>
<span class="n">Hs</span><span class="p">,</span><span class="n">T</span><span class="p">,</span><span class="n">C</span><span class="p">,</span><span class="n">Ttime</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">meanParameters</span><span class="p">(</span><span class="n">ds_sector</span><span class="p">,</span> <span class="n">distance</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">)</span>
    
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># example point</span>
<span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">5</span><span class="p">,</span><span class="mi">5</span><span class="p">)</span>
<span class="n">fig</span><span class="p">,</span> <span class="n">ax</span> <span class="o">=</span> <span class="n">plot_sat</span><span class="o">.</span><span class="n">map_init</span><span class="p">(</span><span class="n">figsize</span><span class="p">)</span>
<span class="n">ax</span> <span class="o">=</span> <span class="n">plot_sat</span><span class="o">.</span><span class="n">map_settings</span><span class="p">(</span><span class="n">ax</span><span class="p">)</span>

<span class="c1">#ax.set_extent([lon1_P-5, lon2_P+5, lat1_P-5, lat2_P+5])</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">site_lon</span><span class="p">,</span> <span class="n">site_lat</span><span class="p">,</span> <span class="n">markersize</span><span class="o">=</span><span class="mi">7</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;red&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ccrs</span><span class="o">.</span><span class="n">PlateCarree</span><span class="p">(),</span> <span class="n">zorder</span><span class="o">=</span><span class="mi">3</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="n">site</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">(</span><span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">,</span> <span class="n">markersize</span><span class="o">=</span><span class="mi">7</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;o&#39;</span><span class="p">,</span> <span class="n">color</span><span class="o">=</span><span class="s1">&#39;k&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ccrs</span><span class="o">.</span><span class="n">PlateCarree</span><span class="p">(),</span> <span class="n">zorder</span><span class="o">=</span><span class="mi">2</span><span class="p">,</span> <span class="n">label</span><span class="o">=</span><span class="s1">&#39;Observation point&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">plot</span><span class="p">([</span><span class="n">lon_coor</span><span class="p">,</span> <span class="n">site_lon</span><span class="p">],</span> <span class="p">[</span><span class="n">lat_coor</span><span class="p">,</span> <span class="n">site_lat</span><span class="p">],</span> <span class="s1">&#39;--&#39;</span><span class="p">,</span> <span class="n">c</span><span class="o">=</span><span class="s1">&#39;dimgray&#39;</span><span class="p">,</span> <span class="n">transform</span><span class="o">=</span><span class="n">ccrs</span><span class="o">.</span><span class="n">Geodetic</span><span class="p">(),</span> <span class="n">zorder</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s1">&#39;upper left&#39;</span><span class="p">)</span>
<span class="n">ax</span><span class="o">.</span><span class="n">set_title</span><span class="p">(</span><span class="s1">&#39;Distance: </span><span class="si">{0:.2f}</span><span class="s1"> m</span><span class="se">\n</span><span class="s1"> Bearing Obs: </span><span class="si">{1:.2f}</span><span class="s1">º</span><span class="se">\n</span><span class="s1"> Bearing Samoa.: </span><span class="si">{2:.2f}</span><span class="s1">º&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">distance</span><span class="p">,</span> <span class="n">bearing</span><span class="p">,</span> <span class="n">bearing_p1</span><span class="p">))</span>

<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># Plot masked spectra</span>
<span class="n">Hs</span><span class="p">,</span><span class="n">T</span><span class="p">,</span><span class="n">C</span><span class="p">,</span><span class="n">Ttime</span> <span class="o">=</span> <span class="n">spectra</span><span class="o">.</span><span class="n">meanParameters</span><span class="p">(</span><span class="n">ds_sector</span><span class="p">,</span> <span class="n">distance</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">)</span>
<span class="nb">print</span><span class="p">(</span><span class="s1">&#39;Hs: </span><span class="si">{0}</span><span class="se">\n</span><span class="s1">T: </span><span class="si">{1}</span><span class="se">\n</span><span class="s1">C: </span><span class="si">{2}</span><span class="se">\n</span><span class="s1">Travel time: </span><span class="si">{3}</span><span class="s1">&#39;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">Hs</span><span class="p">,</span> <span class="n">T</span><span class="p">,</span> <span class="n">C</span><span class="p">,</span> <span class="n">Ttime</span><span class="p">))</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="n">sector</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">ds_spectra</span><span class="o">.</span><span class="n">theta</span><span class="o">.</span><span class="n">values</span> <span class="o">-</span> <span class="n">bearing</span><span class="p">))</span>
<span class="n">ds_mask</span> <span class="o">=</span> <span class="n">ds_spectra</span><span class="o">.</span><span class="n">where</span><span class="p">(</span><span class="n">ds_spectra</span><span class="o">.</span><span class="n">theta</span><span class="o">==</span><span class="n">ds_spectra</span><span class="o">.</span><span class="n">theta</span><span class="o">.</span><span class="n">values</span><span class="p">[</span><span class="n">sector</span><span class="p">])</span>
</pre></div>
</div>
</div>
</div>
<div class="cell docutils container">
<div class="cell_input docutils container">
<div class="highlight-ipython3 notranslate"><div class="highlight"><pre><span></span><span class="c1"># partitions-spectra map</span>
<span class="n">fig</span> <span class="o">=</span> <span class="n">plt</span><span class="o">.</span><span class="n">figure</span><span class="p">(</span><span class="n">figsize</span><span class="o">=</span><span class="p">(</span><span class="mi">7</span><span class="p">,</span><span class="mi">7</span><span class="p">),</span> <span class="n">constrained_layout</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>

<span class="n">fig</span> <span class="o">=</span> <span class="n">plot_spectra</span><span class="o">.</span><span class="n">plotSpectra</span><span class="p">(</span><span class="n">fig</span><span class="p">,</span> <span class="n">ds_mask</span><span class="o">.</span><span class="n">slopeD</span><span class="p">,</span> <span class="n">mask_comb</span><span class="p">,</span> <span class="n">K_SPECTRA</span><span class="p">,</span> 
                  <span class="n">num_box</span><span class="p">,</span> <span class="n">nadir_side</span><span class="p">,</span>
                  <span class="n">N_PHI</span><span class="p">,</span> <span class="n">k_min</span><span class="p">,</span> <span class="n">k_max</span><span class="p">,</span>
                  <span class="n">vmin</span><span class="p">,</span> <span class="n">vmax</span><span class="p">,</span> <span class="n">partitions</span><span class="p">,</span>
                  <span class="n">lon_coor</span><span class="p">,</span> <span class="n">lat_coor</span><span class="p">,</span> <span class="n">date</span><span class="p">)</span>
</pre></div>
</div>
</div>
</div>
</div>
</div>

    <script type="text/x-thebe-config">
    {
        requestKernel: true,
        binderOptions: {
            repo: "binder-examples/jupyter-stacks-datascience",
            ref: "master",
        },
        codeMirrorConfig: {
            theme: "abcdef",
            mode: "conda-env-testCf-py"
        },
        kernelOptions: {
            kernelName: "conda-env-testCf-py",
            path: "./."
        },
        predefinedOutput: true
    }
    </script>
    <script>kernelName = 'conda-env-testCf-py'</script>

              </div>
              
        
        <div class='prev-next-bottom'>
            
    <a class='left-prev' id="prev-link" href="SF4_Partitions_ModelCFOSAT.html" title="previous page">Comparison between WW3 model and CFOSAT partitions</a>
    <a class='right-next' id="next-link" href="SF6_SwellField_Reconstruction.html" title="next page">Swell Field reconstruction</a>

        </div>
        
        </div>
    </div>
    <footer class="footer mt-5 mt-md-0">
    <div class="container">
      <p>
        
          By The Jupyter Book Community<br/>
        
            &copy; Copyright 2021.<br/>
      </p>
    </div>
  </footer>
</main>


      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  
  </body>
</html>